import numpy as np

from ska_sdp_distributed_self_cal_prototype.processing_tasks.clean_beam import gaussian_2d


def test_gaussian_2d():
    # Arrange
    sigma_x = 11.713030353182782
    sigma_y = 11.301812073532487
    position_angle = -1645.3224920756281
    x_pixels = 15
    y_pixels = 15
    expected_gaussian_values = np.array(
        [
            [
                0.60945375,
                0.64770506,
                0.68254402,
                0.71318287,
                0.73890394,
                0.75908763,
                0.77323712,
                0.78099873,
                0.78217658,
                0.77674084,
                0.76482896,
                0.7467399,
                0.72292166,
                0.69395286,
                0.66051937,
            ],
            [
                0.64948147,
                0.69007961,
                0.72702356,
                0.75947699,
                0.78667908,
                0.8079741,
                0.82283759,
                0.8308979,
                0.83195157,
                0.82597192,
                0.81311012,
                0.79368889,
                0.76818901,
                0.73722953,
                0.70154286,
            ],
            [
                0.68602332,
                0.72873096,
                0.76756013,
                0.8016309,
                0.83014381,
                0.85241106,
                0.86788396,
                0.8761755,
                0.87707633,
                0.87056365,
                0.8568021,
                0.83613684,
                0.80907923,
                0.77628571,
                0.73853142,
            ],
            [
                0.71821937,
                0.76274849,
                0.80319768,
                0.8386493,
                0.86827077,
                0.89134703,
                0.9073092,
                0.91575787,
                0.9164797,
                0.90945642,
                0.89486554,
                0.87307294,
                0.84461759,
                0.81018942,
                0.77060152,
            ],
            [
                0.74528341,
                0.79130079,
                0.83306444,
                0.86962585,
                0.90012565,
                0.92382707,
                0.94014552,
                0.94867253,
                0.94919277,
                0.94169306,
                0.92636292,
                0.90358666,
                0.8739273,
                0.8381035,
                0.7969606,
            ],
            [
                0.76653486,
                0.81366935,
                0.85640828,
                0.89377995,
                0.92490517,
                0.94903156,
                0.96556376,
                0.9740878,
                0.9743884,
                0.96645793,
                0.95049679,
                0.92690496,
                0.89626535,
                0.85931987,
                0.81693961,
            ],
            [
                0.78142711,
                0.82927854,
                0.87262818,
                0.91048938,
                0.94197069,
                0.96631059,
                0.98290817,
                0.99134768,
                0.99141595,
                0.98311122,
                0.96664333,
                0.94242481,
                0.91105378,
                0.87328936,
                0.83002117,
            ],
            [
                0.78957094,
                0.83772025,
                0.88129989,
                0.91931696,
                0.95087555,
                0.97521178,
                0.9917245,
                1.0,
                0.99982918,
                0.99121636,
                0.97437912,
                0.94973912,
                0.91790457,
                0.87964531,
                0.83586184,
            ],
            [
                0.79075136,
                0.83877158,
                0.88219444,
                0.92002955,
                0.95138453,
                0.97549994,
                0.99177979,
                0.99981608,
                0.99940571,
                0.99055909,
                0.97349964,
                0.94865447,
                0.91663654,
                0.87821961,
                0.8343071,
            ],
            [
                0.78493709,
                0.83240468,
                0.8752881,
                0.91260825,
                0.94348414,
                0.96716744,
                0.98307257,
                0.99080079,
                0.99015676,
                0.98115681,
                0.96402819,
                0.9391996,
                0.90728329,
                0.86905003,
                0.82539815,
            ],
            [
                0.77228191,
                0.81878793,
                0.86076351,
                0.89724927,
                0.92738322,
                0.95043451,
                0.96583294,
                0.97319234,
                0.97232667,
                0.96325787,
                0.9462149,
                0.92162416,
                0.89009174,
                0.8523786,
                0.8093701,
            ],
            [
                0.75311794,
                0.79827855,
                0.83900159,
                0.87435531,
                0.90350378,
                0.9257396,
                0.94051248,
                0.94745182,
                0.94638218,
                0.93733066,
                0.92052576,
                0.89638776,
                0.86551129,
                0.82864098,
                0.78664164,
            ],
            [
                0.72794108,
                0.77140705,
                0.81056496,
                0.84451798,
                0.87246261,
                0.89372025,
                0.90776456,
                0.91424311,
                0.9129921,
                0.90404322,
                0.88762233,
                0.86413997,
                0.83417433,
                0.79844755,
                0.75779689,
            ],
            [
                0.69738978,
                0.73885439,
                0.77617381,
                0.80849244,
                0.83504483,
                0.85518577,
                0.86841636,
                0.87440448,
                0.87299871,
                0.86423466,
                0.84833348,
                0.82569258,
                0.79686915,
                0.76255731,
                0.72356045,
            ],
            [
                0.6622181,
                0.70142336,
                0.73667555,
                0.76716563,
                0.79217087,
                0.81108328,
                0.82343416,
                0.8289134,
                0.82738242,
                0.81888002,
                0.80362068,
                0.78198565,
                0.75450708,
                0.72184624,
                0.68476717,
            ],
        ]
    )

    # Act
    gaussian_values = gaussian_2d(sigma_x, sigma_y, position_angle, x_pixels, y_pixels)

    # Assert
    np.testing.assert_array_almost_equal(gaussian_values, expected_gaussian_values)
